--[[
	This script translates BrainFuck code. 
	
	this can do these syntax symbols 
	>
	<
	+
	-
	[
	]
	.
]]

local utf8 = require("utf8")

local BFString = ""

local subs = {
	["+"] = "cells[currentCell] = (cells[currentCell] or 0) + 1",
	["-"] = "cells[currentCell] = (cells[currentCell] or 0) - 1",
	["."] = "io.write(string.char(cells[currentCell]))",
	[">"] = "currentCell=(currentCell+1)%30000",
	["<"] = "currentCell=(currentCell-1)%30000",
	["["] = "while cells[currentCell]~=0 do",
	["]"] = "end",
}

function interpret(bfStr)

	currentCell = 1
	cells = {}
	
	local function compile(source)
		local result = {
		}
		for char in source:gmatch(".") do
			if subs[char] then
				table.insert(result, subs[char])
			end
		end
		return loadstring(table.concat(result, "\n"))
	end
	
	local BFStringTab = {}
	
	for i2 = 1, string.len(bfStr) do -- split up each individual character in string 
		table.insert(BFStringTab,string.sub(bfStr,i2,i2))
	end
	
	local chunk,err = compile(bfStr)
	
	if chunk then
		chunk()
	else
		print("ERROR: " .. err)
		return
	end
	
	for i, cellVal in pairs(cells) do
		cellVal = nil
	end

	for i,v in ipairs(BFStringTab) do
		table.remove(BFStringTab, i)
	end
end




function love.update()
	BFString = io.read()
	interpret(BFString)
end

